'	GeoToMqo

Option Explicit

Dim iObj, iMat, Material, Vertex, Face, Objects, iVertex, iFace, ALPHA, Texture, TextureFileName, Scale

'XP[ݒ
Scale = 100
'Scale = 1000

'C

If LCase( Right(WScript.FullName, 11) ) = "wscript.exe" Then
	If WScript.Arguments.count = 1 Then
		GeoToMqo WScript.Arguments(0)
	Else
		WScript.Echo "geot@ChbvĂ"
	End If
Else
	'HotVBSfobOp
	FileDialog.Filter = "GEOt@C(*.geo)|*.geo|SẴt@C(*.*)|*.*"	't@C}XNitB^j
	If FileDialog.ShowOpen Then
		GeoToMqo FileDialog.FileName
	End If
End If

'֐ATu[`

Sub GeoToMqo(GeoFileName)
	Dim objFileSys, MqoFileName, S
	Set objFileSys = CreateObject("Scripting.FileSystemObject")
	If objFileSys.FileExists(GeoFileName) And objFileSys.GetExtensionName(GeoFileName) = "geo" Then
		MqoFileName = objFileSys.GetParentFolderName(GeoFileName) & "\" & objFileSys.getBaseName(GeoFileName) & ".mqo" 
		TextureFileName = objFileSys.getBaseName(GeoFileName) & ".bmp" 
		S = OpenTextFile(GeoFileName)
		S = GetMqoText(S)
		SaveTextFile MqoFileName, S
	Else
		WScript.Echo "ugeot@CvhbvĂ"
	End If
End Sub


Function GetMqoText(S)
	Dim i, Mqo, Geo
	Geo = Split(S, VbCrLf)
	i = 0
	iMat = - 1
	iObj = - 1
	Material = ""
	Objects = ""
	ALPHA = "1.0"
	'geomqo
	Do While i <= UBound(Geo)
		'[h
		If      InStr(Geo(i), "OBJECT BODY") = 1 Then
			GetBody Geo, i
		ElseIf InStr(Geo(i), "OBJECT ONE_WHEEL") = 1 Then
			GetWheel Geo, i, 1
		ElseIf InStr(Geo(i), "OBJECT TWO_WHEEL") = 1 Then
			GetWheel Geo, i, 2
		ElseIf InStr(Geo(i), "OBJECT PROPELLER") = 1 Then
			GetProp Geo, i
		ElseIf InStr(Geo(i), "END") = 1 Then
			Exit Do
		End If
		i = i + 1
	Loop
	Material = "Material " & (iMat + 1) & " {" & VbCrLf & Material & "}" & VbCrLf
	'MqoeLXg
	Mqo = "Metasequoia Document" & VbCrLf
	Mqo = Mqo & "Format Text Ver 1.0" & VbCrLf
	Mqo = Mqo & VbCrLf
	Mqo = Mqo & "Scene {" & VbCrLf
	Mqo = Mqo & "	pos -33.8769 2.3164 1500.0000" & VbCrLf
	Mqo = Mqo & "	lookat 0.0000 0.0000 0.0000" & VbCrLf
	Mqo = Mqo & "	head 1.8292" & VbCrLf
	Mqo = Mqo & "	pich 0.1800" & VbCrLf
	Mqo = Mqo & "	ortho 0" & VbCrLf
	Mqo = Mqo & "	zoom2 7.1211" & VbCrLf
	Mqo = Mqo & "	amb 0.250 0.250 0.250" & VbCrLf
	Mqo = Mqo & "}" & VbCrLf
	GetMqoText = Mqo & Material & Objects & VbCrLf & "Eof"
End Function

Sub AddMaterial(sMat)
	Dim S
	'}eAǉ
	iMat = iMat + 1
	S = Split(sMat, " ")
	If Texture Then
		Material = Material & "	""mat" & iMat & """ col(1.0 1.0 1.0 1.0) dif(1.0) amb(0.6) emi(0.0) spc(0.0) power(1.0)"
		Material = Material & " tex(""" & TextureFileName & """)"
	else
		Material = Material & "	""mat" & iMat & """ col(" & S(1) & " " & S(2) & " " & S(3) & " " & ALPHA & ") dif(1.0) amb(0.6) emi(0.0) spc(0.0) power(1.0)"
	End If
	Material = Material & VbCrLf
End Sub

Sub AddObject()
	'Object(vertex+face)ǉ
	If iFace >= 0 Then
		iObj = iObj + 1
		Objects = Objects & "Object ""obj" & iObj & """ {" & VbCrLf
		Objects = Objects & "	visible 15" & VbCrLf
		Objects = Objects & "	locking 0" & VbCrLf
		Objects = Objects & "	shading 1" & VbCrLf
		Objects = Objects & "	facet 59.5" & VbCrLf
		Objects = Objects & "	color 0.898 0.498 0.698" & VbCrLf
		Objects = Objects & "	color_type 0" & VbCrLf
		Objects = Objects & "	vertex " & (iVertex + 1) & " {" & VbCrLf
		Objects = Objects & Vertex
		Objects = Objects & "	}" & VbCrLf
		Objects = Objects & "	face " & (iFace+1) & " {" & VbCrLf
		Objects = Objects & Face
		Objects = Objects & "	}" & VbCrLf
		Objects = Objects & "}" & VbCrLf
		'NA
		Vertex = ""
		Face = ""
		iVertex = - 1
		iFace = - 1
	End If
End Sub

Function GetDataCount(ByRef S)
	Dim i
	i = InStr(S, "//")
	If i > 0 Then
		S = Left(S, i - 1)
	End If
	S = Trim(S)
	GetDataCount = UBound(Split(S, " ")) + 1
End Function

Sub GetBody(Geo, ByRef i)
	Dim PType, sMat, newMat, S, UV, pFace, p
	Texture = False
	newMat = False
	PType = 4
	pFace = 0
	iVertex = - 1
	iFace = - 1
	ALPHA = "1.0"
	Vertex = ""
	Face = ""
	UV = ""
	sMat = " 1 1 1"
	i = i + 5
	Do While (i <= UBound(Geo)) And _
			(InStr(Geo(i), "END") <> 1) And _
			(InStr(Geo(i), "SHADOW") <> 1) And _
			(InStr(Geo(i), "OBJECT") <> 1) 
		'[h
		If InStr(Geo(i), "QUADS") = 1 Then
			PType = 4
		ElseIf InStr(Geo(i), "TRIANGLES") = 1 Then
			PType = 3
		'f[^
		ElseIf InStr(Geo(i), "TEXTURE OFF") = 1 Then
			Texture = False
			newMat = True
		ElseIf InStr(Geo(i), "TEXTURE ON") = 1 Then
			Texture = True
			newMat = True
		ElseIf InStr(Geo(i), "COLOR") = 1 Then
			'Fw
			sMat = Geo(i)
			'ALPHA = "1.0"
			newMat = True
		ElseIf InStr(Geo(i), "ALPHA") = 1 Then
			' sx
			ALPHA = Split(Geo(i), " ")(1)
			newMat = True
		ElseIf InStr(Geo(i), "CULL") = 1 Then
			'
		ElseIf GetDataCount(Geo(i)) >= 3 Then
			If newMat Then
				'IuWFNgǉ
				AddObject
				'}eAǉ
				AddMaterial sMat
				newMat = False
			End If
			'|S̒_W
			If (PType = 3) Or (PType = 4) Then
				S = Split(Geo(i), " ")
				'vertexXV
				iVertex = iVertex + 1
				If UBound(S) = 2 Then
					Vertex = Vertex & "		" & CStr(CDbl(S(1)) * Scale) & " " & CStr(CDbl(S(2)) * Scale) & " " & CStr(CDbl(S(0)) * Scale) & VbCrLf
				ElseIf UBound(S) = 4 Then
					Vertex = Vertex & "		" & CStr(CDbl(S(3)) * Scale) & " " & CStr(CDbl(S(4)) * Scale) & " " & CStr(CDbl(S(2)) * Scale) & VbCrLf
					UV = CStr(CDbl(S(0)) / 256) & " " & CStr(CDbl(S(1)) / 256) & " " & UV
				End If
				'faceXV
				pFace = pFace + 1
				If pFace = PType Then
					iFace = iFace+1
					Face = Face & "		" & pFace & " V("
					For p = 0 To pFace - 1
						Face = Face & (iVertex - p)
						If P < pFace - 1 Then
							Face = Face & " "
						End If
					Next
					Face = Face & ") M(" & iMat & ")"
					If Texture Then
						Face = Face & " UV(" & Trim(UV) & ")"
					End If
					Face = Face & VbCrLf
					UV = ""
					pFace = 0
				End If
			End If
		End If
		i = i + 1
	Loop
	'IuWFNgǉ
	AddObject
	i = i - 1
End Sub

Sub GetProp(Geo, ByRef i)
	Dim r, j, sMat, xyz, BLURR, x, y, z, p, pi
	i = i + 1
	pi = 4 * Atn(1)
	BLURR = False
	Texture = False
	r = ""
	sMat = ""
	ALPHA = ""
	xyz = ""
	Do While i <= UBound(Geo) And _
			(InStr(Geo(i), "END") <> 1) And _
			(InStr(Geo(i), "OUTLINE_COLOR") <> 1) And _
			(InStr(Geo(i), "OBJECT") <> 1)
		If GetDataCount(Geo(i)) >= 1 Then
			If R = "" Then
				R = Geo(i)
			ElseIf sMat = "" Then
				sMat = " " & Geo(i)
			ElseIf xyz = "" Then
				xyz = Geo(i)
			ElseIf InStr(Geo(i), "BLURR_COLOR") > 0 Then
				BLURR = True
			ElseIf BLURR And ALPHA = "" Then
				ALPHA = Geo(i)
			End If
		End If
		i = i + 1
	Loop
	'}eAǉ
	If 	ALPHA = "" Then
		ALPHA = "0.7"
	End If
	AddMaterial sMat
	'W
	r = CDbl(r) * Scale
	xyz = Split(xyz, " ")
	x = CDbl(xyz(1)) * Scale
	y = CDbl(xyz(2)) * Scale
	z = CDbl(xyz(0)) * Scale
	' |S
	For j = 0 To 11
		'vertexXV
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x                             & " " & y                             & " " & z & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x + r * Sin(j / 6 * pi)       & " " & y + r * Cos(j / 6 * pi)       & " " & z & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x + r * Sin((j + 1) / 6 * pi) & " " & y + r * Cos((j + 1) / 6 * pi) & " " & z & VbCrLf
		'faceXV
		iFace = iFace+1
		Face = Face & "		3 V("
		For p = 0 To 2
			Face = Face & (iVertex - p)
			If P < 2 Then
				Face = Face & " "
			End If
		Next
		Face = Face & ") M(" & iMat & ")"
		Face = Face & VbCrLf
		'faceXV
		iFace = iFace+1
		Face = Face & "		3 V("
		For p = 2 To 0 Step - 1
			Face = Face & (iVertex - p)
			If P > 0 Then
				Face = Face & " "
			End If
		Next
		Face = Face & ") M(" & iMat & ")"
		Face = Face & VbCrLf
	Next
	'IuWFNgǉ
	AddObject
	i = i - 1
End Sub

Sub AddWheel(r, x, y, z)
	Dim j, p, pi, dx
	pi = 4 * Atn(1)
	dx = r / 4
	'}eAǉ
	ALPHA = "1.0"
	Texture = False
	AddMaterial " 0.1 0.1 0.1"
	For j = 0 To 11
		'vertexXV
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x + dx & " " & y                             & " " & z                            & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x + dx & " " & y + r * Cos(j / 6 * pi)       & " " & z + r * Sin(j / 6 * pi)       & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x + dx & " " & y + r * Cos((j + 1) / 6 * pi) & " " & z + r * Sin((j + 1) / 6 * pi) & VbCrLf
		'faceXV
		iFace = iFace+1
		Face = Face & "		3 V("
		For p = 0 To 2
			Face = Face & (iVertex - p)
			If P < 2 Then
				Face = Face & " "
			End If
		Next
		Face = Face & ") M(" & iMat & ")"
		Face = Face & VbCrLf
		'vertexXV
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x - dx & " " & y                             & " " & z                            & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x - dx & " " & y + r * Cos(j / 6 * pi)       & " " & z + r * Sin(j / 6 * pi)       & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x - dx & " " & y + r * Cos((j + 1) / 6 * pi) & " " & z + r * Sin((j + 1) / 6 * pi) & VbCrLf
		'faceXV
		iFace = iFace+1
		Face = Face & "		3 V("
		For p = 2 To 0 Step - 1
			Face = Face & (iVertex - p)
			If P > 0 Then
				Face = Face & " "
			End If
		Next
		Face = Face & ") M(" & iMat & ")"
		Face = Face & VbCrLf
		'vertexXV
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x - dx & " " & y + r * Cos(j / 6 * pi)       & " " & z + r * Sin(j / 6 * pi)       & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x - dx & " " & y + r * Cos((j + 1) / 6 * pi) & " " & z + r * Sin((j + 1) / 6 * pi) & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x + dx & " " & y + r * Cos((j + 1) / 6 * pi) & " " & z + r * Sin((j + 1) / 6 * pi) & VbCrLf
		iVertex = iVertex + 1
		Vertex = Vertex & "		" & x + dx & " " & y + r * Cos(j / 6 * pi)       & " " & z + r * Sin(j / 6 * pi)       & VbCrLf
		'faceXV
		iFace = iFace+1
		Face = Face & "		4 V("
		For p = 0 To 3
			Face = Face & (iVertex - p)
			If P < 3 Then
				Face = Face & " "
			End If
		Next
		Face = Face & ") M(" & iMat & ")"
		Face = Face & VbCrLf
	Next
	'IuWFNgǉ
	AddObject
End Sub

Sub GetWheel(Geo, ByRef i, nWheel)
	Dim r, j, direction, xyz, x, y, z
	i = i + 1
	r = ""
	direction = ""
	xyz = ""
	Do While i <= UBound(Geo) And _
			(InStr(Geo(i), "END") <> 1) And _
			(InStr(Geo(i), "OBJECT") <> 1)
		If GetDataCount(Geo(i)) >= 1 Then
			If r = "" Then
				r = Geo(i)
			ElseIf direction = "" Then
				direction = Geo(i)
			ElseIf xyz = "" Then
				xyz = Geo(i)
			End If
		End If
		i = i + 1
	Loop
	'W
	r = CDbl(r) * Scale
	xyz = Split(xyz, " ")
	x = CDbl(xyz(1)) * Scale
	y = CDbl(xyz(2)) * Scale
	z = CDbl(xyz(0)) * Scale
	AddWheel r, x, y, z
	If x <> 0 And nWheel = 2 Then
		x = - x
		AddWheel r, x, y, z
	End If
	i = i - 1
End Sub

Function OpenTextFile(AFileName)
	'AFileNamẽeLXgt@CJ
	Dim fso, MyFile
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set MyFile = fso.OpenTextFile(AFileName, 1, False)
	OpenTextFile = MyFile.ReadAll
	MyFile.Close
End Function

Sub SaveTextFile(AFileName, AText)
	'AText̕AAFileName̖OŃeLXgt@Cۑ
	Dim fso, MyFile
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set MyFile = fso.OpenTextFile(AFileName, 2, True)
	MyFile.Write AText
	MyFile.Close
End Sub
